// ------------------------------------------------------------------------
// $RCSfile: DragtFinnMap.cpp,v $
// ------------------------------------------------------------------------
// $Revision: 1.3 $
// ------------------------------------------------------------------------
// Copyright: see Copyright.readme
// ------------------------------------------------------------------------
//
// Template class: DragtFinnMap<N>
//
// ------------------------------------------------------------------------
// Class category: FixedAlgebra
// ------------------------------------------------------------------------
//
// $Date: 2001/11/15 08:52:26 $
// $Author: jsberg $
//
// ------------------------------------------------------------------------
#include <FixedAlgebra/DragtFinnMap.h>

template <>
FMatrix<double, 6, 6> DragtFinnMap<3>::
makeMatrix(const FLieGenerator<double, 3> &f_2) {
    FMatrix<double, 6, 6> M;

    M(0, 0) = - f_2[8];
    M(0, 1) = - 2.0 * f_2[13];
    M(0, 2) = - f_2[14];
    M(0, 3) = - f_2[15];
    M(0, 4) = - f_2[16];
    M(0, 5) = - f_2[17];

    M(1, 0) = 2.0 * f_2[7];
    M(1, 1) = f_2[8];
    M(1, 2) = f_2[9];
    M(1, 3) = f_2[10];
    M(1, 4) = f_2[11];
    M(1, 5) = f_2[12];

    M(2, 0) = - f_2[10];
    M(2, 1) = - f_2[15];
    M(2, 2) = - f_2[19];
    M(2, 3) = - 2.0 * f_2[22];
    M(2, 4) = - f_2[23];
    M(2, 5) = - f_2[24];

    M(3, 0) = f_2[9];
    M(3, 1) = f_2[14];
    M(3, 2) = 2.0 * f_2[18];
    M(3, 3) = f_2[19];
    M(3, 4) = f_2[20];
    M(3, 5) = f_2[21];

    M(4, 0) = - f_2[12];
    M(4, 1) = - f_2[17];
    M(4, 2) = - f_2[21];
    M(4, 3) = - f_2[24];
    M(4, 4) = - f_2[26];
    M(4, 5) = - 2.0 * f_2[27];

    M(5, 0) = f_2[11];
    M(5, 1) = f_2[16];
    M(5, 2) = f_2[20];
    M(5, 3) = f_2[23];
    M(5, 4) = 2.0 * f_2[25];
    M(5, 5) = f_2[26];

    return M;
}
